<?php

// File generated from our OpenAPI spec

namespace StripeWPFS\Util;

class ObjectTypes
{
    /**
     * @var array Mapping from object types to resource classes
     */
    const mapping = [
        \StripeWPFS\Account::OBJECT_NAME => \StripeWPFS\Account::class,
        \StripeWPFS\AccountLink::OBJECT_NAME => \StripeWPFS\AccountLink::class,
        \StripeWPFS\AlipayAccount::OBJECT_NAME => \StripeWPFS\AlipayAccount::class,
        \StripeWPFS\ApplePayDomain::OBJECT_NAME => \StripeWPFS\ApplePayDomain::class,
        \StripeWPFS\ApplicationFee::OBJECT_NAME => \StripeWPFS\ApplicationFee::class,
        \StripeWPFS\ApplicationFeeRefund::OBJECT_NAME => \StripeWPFS\ApplicationFeeRefund::class,
        \StripeWPFS\Balance::OBJECT_NAME => \StripeWPFS\Balance::class,
        \StripeWPFS\BalanceTransaction::OBJECT_NAME => \StripeWPFS\BalanceTransaction::class,
        \StripeWPFS\BankAccount::OBJECT_NAME => \StripeWPFS\BankAccount::class,
        \StripeWPFS\BillingPortal\Configuration::OBJECT_NAME => \StripeWPFS\BillingPortal\Configuration::class,
        \StripeWPFS\BillingPortal\Session::OBJECT_NAME => \StripeWPFS\BillingPortal\Session::class,
        \StripeWPFS\BitcoinReceiver::OBJECT_NAME => \StripeWPFS\BitcoinReceiver::class,
        \StripeWPFS\BitcoinTransaction::OBJECT_NAME => \StripeWPFS\BitcoinTransaction::class,
        \StripeWPFS\Capability::OBJECT_NAME => \StripeWPFS\Capability::class,
        \StripeWPFS\Card::OBJECT_NAME => \StripeWPFS\Card::class,
        \StripeWPFS\Charge::OBJECT_NAME => \StripeWPFS\Charge::class,
        \StripeWPFS\Checkout\Session::OBJECT_NAME => \StripeWPFS\Checkout\Session::class,
        \StripeWPFS\Collection::OBJECT_NAME => \StripeWPFS\Collection::class,
        \StripeWPFS\CountrySpec::OBJECT_NAME => \StripeWPFS\CountrySpec::class,
        \StripeWPFS\Coupon::OBJECT_NAME => \StripeWPFS\Coupon::class,
        \StripeWPFS\CreditNote::OBJECT_NAME => \StripeWPFS\CreditNote::class,
        \StripeWPFS\CreditNoteLineItem::OBJECT_NAME => \StripeWPFS\CreditNoteLineItem::class,
        \StripeWPFS\Customer::OBJECT_NAME => \StripeWPFS\Customer::class,
        \StripeWPFS\CustomerBalanceTransaction::OBJECT_NAME => \StripeWPFS\CustomerBalanceTransaction::class,
        \StripeWPFS\Discount::OBJECT_NAME => \StripeWPFS\Discount::class,
        \StripeWPFS\Dispute::OBJECT_NAME => \StripeWPFS\Dispute::class,
        \StripeWPFS\EphemeralKey::OBJECT_NAME => \StripeWPFS\EphemeralKey::class,
        \StripeWPFS\Event::OBJECT_NAME => \StripeWPFS\Event::class,
        \StripeWPFS\ExchangeRate::OBJECT_NAME => \StripeWPFS\ExchangeRate::class,
        \StripeWPFS\File::OBJECT_NAME => \StripeWPFS\File::class,
        \StripeWPFS\File::OBJECT_NAME_ALT => \StripeWPFS\File::class,
        \StripeWPFS\FileLink::OBJECT_NAME => \StripeWPFS\FileLink::class,
        \StripeWPFS\Identity\VerificationReport::OBJECT_NAME => \StripeWPFS\Identity\VerificationReport::class,
        \StripeWPFS\Identity\VerificationSession::OBJECT_NAME => \StripeWPFS\Identity\VerificationSession::class,
        \StripeWPFS\Invoice::OBJECT_NAME => \StripeWPFS\Invoice::class,
        \StripeWPFS\InvoiceItem::OBJECT_NAME => \StripeWPFS\InvoiceItem::class,
        \StripeWPFS\InvoiceLineItem::OBJECT_NAME => \StripeWPFS\InvoiceLineItem::class,
        \StripeWPFS\Issuing\Authorization::OBJECT_NAME => \StripeWPFS\Issuing\Authorization::class,
        \StripeWPFS\Issuing\Card::OBJECT_NAME => \StripeWPFS\Issuing\Card::class,
        \StripeWPFS\Issuing\CardDetails::OBJECT_NAME => \StripeWPFS\Issuing\CardDetails::class,
        \StripeWPFS\Issuing\Cardholder::OBJECT_NAME => \StripeWPFS\Issuing\Cardholder::class,
        \StripeWPFS\Issuing\Dispute::OBJECT_NAME => \StripeWPFS\Issuing\Dispute::class,
        \StripeWPFS\Issuing\Transaction::OBJECT_NAME => \StripeWPFS\Issuing\Transaction::class,
        \StripeWPFS\LineItem::OBJECT_NAME => \StripeWPFS\LineItem::class,
        \StripeWPFS\LoginLink::OBJECT_NAME => \StripeWPFS\LoginLink::class,
        \StripeWPFS\Mandate::OBJECT_NAME => \StripeWPFS\Mandate::class,
        \StripeWPFS\Order::OBJECT_NAME => \StripeWPFS\Order::class,
        \StripeWPFS\OrderItem::OBJECT_NAME => \StripeWPFS\OrderItem::class,
        \StripeWPFS\OrderReturn::OBJECT_NAME => \StripeWPFS\OrderReturn::class,
        \StripeWPFS\PaymentIntent::OBJECT_NAME => \StripeWPFS\PaymentIntent::class,
        \StripeWPFS\PaymentLink::OBJECT_NAME => \StripeWPFS\PaymentLink::class,
        \StripeWPFS\PaymentMethod::OBJECT_NAME => \StripeWPFS\PaymentMethod::class,
        \StripeWPFS\Payout::OBJECT_NAME => \StripeWPFS\Payout::class,
        \StripeWPFS\Person::OBJECT_NAME => \StripeWPFS\Person::class,
        \StripeWPFS\Plan::OBJECT_NAME => \StripeWPFS\Plan::class,
        \StripeWPFS\Price::OBJECT_NAME => \StripeWPFS\Price::class,
        \StripeWPFS\Product::OBJECT_NAME => \StripeWPFS\Product::class,
        \StripeWPFS\PromotionCode::OBJECT_NAME => \StripeWPFS\PromotionCode::class,
        \StripeWPFS\Quote::OBJECT_NAME => \StripeWPFS\Quote::class,
        \StripeWPFS\Radar\EarlyFraudWarning::OBJECT_NAME => \StripeWPFS\Radar\EarlyFraudWarning::class,
        \StripeWPFS\Radar\ValueList::OBJECT_NAME => \StripeWPFS\Radar\ValueList::class,
        \StripeWPFS\Radar\ValueListItem::OBJECT_NAME => \StripeWPFS\Radar\ValueListItem::class,
        \StripeWPFS\Recipient::OBJECT_NAME => \StripeWPFS\Recipient::class,
        \StripeWPFS\RecipientTransfer::OBJECT_NAME => \StripeWPFS\RecipientTransfer::class,
        \StripeWPFS\Refund::OBJECT_NAME => \StripeWPFS\Refund::class,
        \StripeWPFS\Reporting\ReportRun::OBJECT_NAME => \StripeWPFS\Reporting\ReportRun::class,
        \StripeWPFS\Reporting\ReportType::OBJECT_NAME => \StripeWPFS\Reporting\ReportType::class,
        \StripeWPFS\Review::OBJECT_NAME => \StripeWPFS\Review::class,
        \StripeWPFS\SetupAttempt::OBJECT_NAME => \StripeWPFS\SetupAttempt::class,
        \StripeWPFS\SetupIntent::OBJECT_NAME => \StripeWPFS\SetupIntent::class,
        \StripeWPFS\ShippingRate::OBJECT_NAME => \StripeWPFS\ShippingRate::class,
        \StripeWPFS\Sigma\ScheduledQueryRun::OBJECT_NAME => \StripeWPFS\Sigma\ScheduledQueryRun::class,
        \StripeWPFS\SKU::OBJECT_NAME => \StripeWPFS\SKU::class,
        \StripeWPFS\Source::OBJECT_NAME => \StripeWPFS\Source::class,
        \StripeWPFS\SourceTransaction::OBJECT_NAME => \StripeWPFS\SourceTransaction::class,
        \StripeWPFS\Subscription::OBJECT_NAME => \StripeWPFS\Subscription::class,
        \StripeWPFS\SubscriptionItem::OBJECT_NAME => \StripeWPFS\SubscriptionItem::class,
        \StripeWPFS\SubscriptionSchedule::OBJECT_NAME => \StripeWPFS\SubscriptionSchedule::class,
        \StripeWPFS\TaxCode::OBJECT_NAME => \StripeWPFS\TaxCode::class,
        \StripeWPFS\TaxId::OBJECT_NAME => \StripeWPFS\TaxId::class,
        \StripeWPFS\TaxRate::OBJECT_NAME => \StripeWPFS\TaxRate::class,
        \StripeWPFS\Terminal\ConnectionToken::OBJECT_NAME => \StripeWPFS\Terminal\ConnectionToken::class,
        \StripeWPFS\Terminal\Location::OBJECT_NAME => \StripeWPFS\Terminal\Location::class,
        \StripeWPFS\Terminal\Reader::OBJECT_NAME => \StripeWPFS\Terminal\Reader::class,
        \StripeWPFS\ThreeDSecure::OBJECT_NAME => \StripeWPFS\ThreeDSecure::class,
        \StripeWPFS\Token::OBJECT_NAME => \StripeWPFS\Token::class,
        \StripeWPFS\Topup::OBJECT_NAME => \StripeWPFS\Topup::class,
        \StripeWPFS\Transfer::OBJECT_NAME => \StripeWPFS\Transfer::class,
        \StripeWPFS\TransferReversal::OBJECT_NAME => \StripeWPFS\TransferReversal::class,
        \StripeWPFS\UsageRecord::OBJECT_NAME => \StripeWPFS\UsageRecord::class,
        \StripeWPFS\UsageRecordSummary::OBJECT_NAME => \StripeWPFS\UsageRecordSummary::class,
        \StripeWPFS\WebhookEndpoint::OBJECT_NAME => \StripeWPFS\WebhookEndpoint::class,
    ];
}
